SoIndexedFaceSet(3)

NAME
SoIndexedFaceSet - The SoIndexedFaceSet class is used to handle generic indexed facesets.

SYNOPSIS

#include <Inventor/nodes/SoIndexedFaceSet.h>

Inherits SoIndexedShape.

  Public Member Functions
virtual SoType getTypeId (void) const
SoIndexedFaceSet (void)
virtual void GLRender (SoGLRenderAction *action)
virtual void getPrimitiveCount (SoGetPrimitiveCountAction *action)
virtual SbBool generateDefaultNormals (SoState *state, SoNormalBundle *bundle)
virtual SbBool generateDefaultNormals (SoState *state, SoNormalCache *cache)

  Static Public Member Functions
static SoType getClassTypeId (void)
static void initClass (void)

  Protected Member Functions
virtual const SoFieldData * getFieldData (void) const
virtual ~SoIndexedFaceSet ()
virtual void generatePrimitives (SoAction *action)

  Static Protected Member Functions
static const SoFieldData ** getFieldDataPtr (void)

  Additional Inherited Members

Detailed Description

The SoIndexedFaceSet class is used to handle generic indexed facesets. Facesets are specified using the coordIndex field. Each face must be terminated by a negative (-1) index. Coordinates, normals, materials and texture coordinates from the current state (or from the vertexProperty node if set), can be indexed to create triangles, quads or polygons.

Here's a usage example of just about the simplest possible use of this node, to show a single polygon face:

#Inventor V2.1 ascii
Separator {
   Coordinate3 {
      point [ 0 0 0, 1 0 0, 1 1 0 ]
   }
   IndexedFaceSet {
      coordIndex [ 0, 1, 2, -1 ]
   }
}

Binding PER_VERTEX_INDEXED, PER_VERTEX, PER_FACE_INDEXED, PER_FACE or OVERALL can be set for material, and normals. The default material binding is OVERALL. The default normal binding is PER_VERTEX_INDEXED. When PER_VERTEX_INDEXED binding is used and the corresponding materialIndex, normalIndex, texCoordIndex field is empty, the coordIndex field will be used to index material, normal or texture coordinate. If you do specify indices for material, normals or texture coordinates for PER_VERTEX_INDEXED binding, make sure your index array matches the coordIndex array: there should be a -1 wherever there is a -1 in the coordIndex field. This is done to make this node more easily readable for humans.

A fairly common request when rendering facesets is how to display a set of faces with different colors on the backside versus the frontside. There is not direct support for this in the API, but it can easily be implemented by duplicating all faces in both the SoShapeHints::COUNTERCLOCKWISE and the SoShapeHints::CLOCKWISE order. Here is a simple usage example, showing the technique for a single polygon, using two SoFaceSet nodes for rendering the same polygon from both sides:

#Inventor V2.1 ascii
Separator {
   Coordinate3 { point [ 0 0 0, 1 0 0, 1 1 0 ] }
   Separator {
      Material { diffuseColor [ 1 1 0 ] }
      ShapeHints {
         vertexOrdering COUNTERCLOCKWISE
         shapeType SOLID
      }
      FaceSet { numVertices [ 3 ] }
   }
   Separator {
      Material { diffuseColor [ 1 0 0 ] }
      ShapeHints {
         vertexOrdering CLOCKWISE
         shapeType SOLID
      }
      FaceSet { numVertices [ 3 ] }
   }
}

The same effect can also be done in the following manner, using an SoIndexedFaceSet to explicitly render the polygon coordinates in both directions (clockwise and counterclockwise):

#Inventor V2.1 ascii
Separator {
   Coordinate3 { point [ 0 0 0, 1 0 0, 1 1 0 ] }
   Material { diffuseColor [ 1 0 0, 1 1 0 ] }
   MaterialBinding { value PER_FACE_INDEXED }
   ShapeHints {
      vertexOrdering COUNTERCLOCKWISE
      shapeType SOLID
   }
   IndexedFaceSet {
      coordIndex [ 0, 1, 2, -1, 2, 1, 0, -1 ]
      materialIndex [ 0, 1 ]
   }
}

Another rather rare issue that might be interesting to know about is that to render polygons with concave borders, you should set up an SoShapeHints node with SoShapeHints::faceType set to SoShapeHints::UNKNOWN_FACE_TYPE in the scene graph before the SoIndexedFaceSet (or SoFaceSet) node. This needs to be done to force the rendering code to tessellate the polygons properly to triangles before sending it off to OpenGL. Without it, the polygons will be sent as-is to OpenGL, and the OpenGL implementation's tessellator is often not able to tessellate properly. Here is an example which usually fails without the SoShapeHints node (try commenting it out, and see what happens):

#Inventor V2.1 ascii
ShapeHints { faceType UNKNOWN_FACE_TYPE }
Coordinate3
{
        point [ 2 0 0,
                1 0 0,
                1 1 0,
                0 1 0,
                0 2 0,
                1 2 0,
                2 2 0,
                2 1 0 ]
}
FaceSet {}

FILE FORMAT/DEFAULTS:

IndexedFaceSet {
    vertexProperty NULL
    coordIndex 0
    materialIndex -1
    normalIndex -1
    textureCoordIndex -1
}

See also
    SoFaceSet, SoIndexedTriangleStripSet

Constructor & Destructor Documentation

  SoIndexedFaceSet::SoIndexedFaceSet (void)
Constructor.

  SoIndexedFaceSet::~SoIndexedFaceSet () [protected], [virtual]
Destructor.

Member Function Documentation

  SoType SoIndexedFaceSet::getClassTypeId (void) [static]
This static method returns the SoType object associated with objects of this class.

  SoType SoIndexedFaceSet::getTypeId (void) const [virtual]
Returns the type identification of an object derived from a class inheriting SoBase. This is used for runtime type checking and 'downward' casting.

Reimplemented from SoIndexedShape.

  const SoFieldData ** SoIndexedFaceSet::getFieldDataPtr (void) [static], [protected]
This API member is considered internal to the library, as it is not likely to be of interest to the application programmer.
 Returns the SoFieldData class which holds information about fields in this node.

  const SoFieldData * SoIndexedFaceSet::getFieldData (void) const [protected], [virtual]
Returns a pointer to the class-wide field data storage object for this instance. If no fields are present, returns NULL.

Reimplemented from SoIndexedShape.

  void SoIndexedFaceSet::initClass (void) [static]

  void SoIndexedFaceSet::GLRender (SoGLRenderAction * action) [virtual]
Action method for the SoGLRenderAction.

This is called during rendering traversals. Nodes influencing the rendering state in any way or want to throw geometry primitives at OpenGL override this method.

Reimplemented from SoShape.

  void SoIndexedFaceSet::getPrimitiveCount (SoGetPrimitiveCountAction * action) [virtual]
Action method for the SoGetPrimitiveCountAction.

Calculates the number of triangle, line segment and point primitives for the node and adds these to the counters of the action.

Nodes influencing how geometry nodes calculate their primitive count also override this method to change the relevant state variables.

Reimplemented from SoShape.

  SbBool SoIndexedFaceSet::generateDefaultNormals (SoState * state, SoNormalBundle * bundle) [virtual]
This API member is considered internal to the library, as it is not likely to be of interest to the application programmer.
 Subclasses should override this method to generate default normals using the SoNormalBundle class. TRUE should be returned if normals were generated, FALSE otherwise.

Default method returns FALSE.

This function is an extension for Coin, and it is not available in the original SGI Open Inventor v2.1 API.

Reimplemented from SoVertexShape.

  SbBool SoIndexedFaceSet::generateDefaultNormals (SoState * state, SoNormalCache * cache) [virtual]
This API member is considered internal to the library, as it is not likely to be of interest to the application programmer.
 Subclasses should override this method to generate default normals using the SoNormalCache class. This is more effective than using SoNormalGenerator. Return TRUE if normals were generated, FALSE otherwise.

Default method just returns FALSE.

This function is an extension for Coin, and it is not available in the original SGI Open Inventor v2.1 API.

Reimplemented from SoVertexShape.

  void SoIndexedFaceSet::generatePrimitives (SoAction * action) [protected], [virtual]
The method implements action behavior for shape nodes for SoCallbackAction. It is invoked from SoShape::callback(). (Subclasses should not override SoNode::callback().)

The subclass implementations uses the convenience methods SoShape::beginShape(), SoShape::shapeVertex(), and SoShape::endShape(), with SoDetail instances, to pass the primitives making up the shape back to the caller.

Implements SoShape.

Author

Generated automatically by Doxygen for Coin from the source code.